<template>
  <div class="panel flex flex-col gap-4">
    <div class="flex items-center gap-4 justify-between">
      <app-integration-manage-item-title :integration="integrationCombined" />
      <div>
        <app-integration-status v-model="status" />
        <app-integration-last-synced v-model="lastSynced" />
        <div class="text-3xs italic text-gray-500 h-5 leading-5 text-end mb-1">
          created at {{ createdAt }}
        </div>
      </div>
    </div>
    <div class="flex justify-end gap-2">
      <el-button
        v-if="connection.status"
        class="btn btn-brand btn-brand--bordered btn--md"
        :loading="loadingDisconnect"
        @click="handleDisconnect"
      >
        Disconnect
      </el-button>

      <app-integration-settings :integration="integrationCombined" />
    </div>
  </div>
</template>

<script setup>
import { computed, defineProps, ref } from 'vue';
import AppIntegrationLastSynced from '@/modules/integration/components/integration-last-synced.vue';
import AppIntegrationStatus from '@/modules/integration/components/integration-status.vue';
import { formatLastSynced, getIntegrationStatus } from '@/modules/integration/integration-utils';
import moment from 'moment';
import AppIntegrationSettings from '@/modules/integration/components/integration-settings.vue';
import AppIntegrationManageItemTitle from '@/modules/integration/components/integration-manage-item-title.vue';
import { useStore } from 'vuex';

const store = useStore();
const props = defineProps({
  integration: {
    type: Object,
    default: () => {
    },
  },
  connection: {
    type: Object,
    default: () => {
    },
  },
});

const integrationCombined = computed(() => ({
  ...props.integration,
  ...props.connection,
}));

const status = computed(() => getIntegrationStatus(props.connection));
const lastSynced = computed(() => formatLastSynced(props.connection));
const createdAt = computed(() => moment(props.connection.createdAt)
  .format('MMM D, YYYY'));

const loadingDisconnect = ref(false);

const handleDisconnect = async () => {
  loadingDisconnect.value = true;
  await store.dispatch('integration/doDestroy', props.connection.id);
  loadingDisconnect.value = false;
};

</script>

<script>

export default {
  name: 'AppIntegrationManageItem',
};
</script>
